CoCoA-5 - Feature #553

Port function MantissaAndExponent2
12 May 2014 18:35 - Anna Maria Bigatti

Status: Closed Start date: 12 May 2014
Priority: Normal Due date:

Assignee: John Abbott % Done: 100%
Category: CoCoA-5 function: new Estimated time: 4.00 hours
Target version: CoCoA-5.1.1 Seoul14 Spent time: 4.25 hours
Description

MantissaAndExponent2 is defined in CoCoALib and mentioned in the manual for CoCoA-5.
Porting it to CoCoA-5 should be easy (copying MantissaAndExponent10)

History

#1 - 12 May 2014 21:29 - John Abbott

- Status changed from New to In Progress
- Assignee set to John Abbott

- % Done changed from 0 to 30

I've just copied the code for MantissaAndExponent10 -- it seems a waste writing code using cut-and-paste :-(

Added the missing entry to the C5 manual.

There is an inconsistency:

MantExp10(0.5,3) produces Record[exp:=-1, mant:=500]
so the value represented is 10*(exp)*mant/10"(numdigits)

MantExp2(0.5,8) produces Record[exp:=-8, mant:=128]
so the value represented is 2*(exp)*mant

Which approach is better?

#2 - 12 May 2014 23:49 - Anna Maria Bigatti
John Abbott wrote:

I've just copied the code for MantissaAndExponent10 -- it seems a waste writing code using cut-and-paste :-(

Added the missing entry to the C5 manual.

There is an inconsistency:

MantExp10(0.5,3) produces Record[exp:=-1, mant:=500]
so the value represented is 10" (exp)*mant/10*(numdigits)

MantExp2(0.5,8) produces Record[exp:=-8, mant:=128]
so the value represented is 2*(exp)*mant

Which approach is better?
I'd like to have Record[exp:=-1, mant:=500, NumDigits:=3]

even though it is a bit redundant.

exp:=-1is the most meaningful information, so it would be a bit odd to have it depending on the number of digits.

On the other hand a direct interpretation of the result, as in the second case, is nice. So it would be nice to give the extra information about numdigits
without having to compute a logarithm.

#3 - 14 May 2014 09:38 - Anna Maria Bigatti

For JAA: commit file for fixing
BuiltinFunctions.C:678: error: 'class CoCoA::MantExp2' has no member named 'myNumbDigits'

12:52 DONE!

#4 - 14 May 2014 15:31 - John Abbott

- Status changed from In Progress to Feedback
- % Done changed from 30 to 90

- Estimated time set to 4.00 h

| have implemented, tested, & documented.
| followed Anna's suggestion: a MantExp2 structure now contains 4 (public) fields
* mySign
* myExponent
e myMantissa
e myNumDigits

The value represented is mySign * myMantissa * 2*(myExponent-myNumDigits+1)

Similarly for MantExp10

#5 - 03 Sep 2014 12:36 - John Abbott
- Status changed from Feedback to Closed
- % Done changed from 90 to 100

10 Apr 2024 22


http://www.tcpdf.org

